local StoneGateBridge = ...

--------------------------------------------------------------------------
local STONE_GATE_PORTCULLIS_COMP = {
	TypeName = "STONE_GATE_PORTCULLIS_COMP",
	ParentType = "COMPONENT",
	Properties = {
		{ Name = "DeltaElevation", Type = "integer", Default = 0 },
		{ Name = "MinDistanceVillager", Type = "integer", Default = 50 },
		{ Name = "SpeedMove", Type = "float", Default = 0.1 }
	}
}

--------------------------------------------------------------------------
function STONE_GATE_PORTCULLIS_COMP:create()
    StoneGateBridge:log("STONE_GATE_PORTCULLIS_COMP:create()")
    self.timer = 0
    self.pos1 = nil
end

--------------------------------------------------------------------------
function STONE_GATE_PORTCULLIS_COMP:init()
    StoneGateBridge:log("STONE_GATE_PORTCULLIS_COMP:init()")
    self.timer = 0
    self.pos1 = nil
end

--------------------------------------------------------------------------
function STONE_GATE_PORTCULLIS_COMP:raise(_deltaElevation)
--    StoneGateBridge:log("STONE_GATE_PORTCULLIS_COMP:raise(" .. _deltaElevation .. ")")
    self:getOwner():move({0, _deltaElevation, 0})
--    StoneGateBridge:log("STONE_GATE_PORTCULLIS_COMP:end raise(" .. _deltaElevation .. ")")
end

--------------------------------------------------------------------------
function STONE_GATE_PORTCULLIS_COMP:portcullisClose(_dt)
--    StoneGateBridge:log("STONE_GATE_PORTCULLIS_COMP:portcullisClose(" .. _dt .. ")")

    local _deltaPosition = -_dt*self.SpeedMove
    if _deltaPosition < (self.pos2 - self:getOwner():getGlobalPosition().y) then
        _deltaPosition = self.pos2 - self:getOwner():getGlobalPosition().y
    end
    self:raise(_deltaPosition)
end

--------------------------------------------------------------------------
function STONE_GATE_PORTCULLIS_COMP:portcullisOpen(_dt)
--    StoneGateBridge:log("STONE_GATE_PORTCULLIS_COMP:portcullisOpen(" .. _dt .. ")")
    local _deltaPosition = _dt*self.SpeedMove
    if _deltaPosition > (self.pos1.y - self:getOwner():getGlobalPosition().y) then
        _deltaPosition = self.pos1.y - self:getOwner():getGlobalPosition().y
    end
    self:raise(_deltaPosition)
    return _deltaPosition == 0
end

--------------------------------------------------------------------------
function STONE_GATE_PORTCULLIS_COMP:computeProximity(_comp, _pos1)
--        StoneGateBridge:log("STONE_GATE_PORTCULLIS_COMP:computeProximity(")
                    local pos2 = _comp:getOwner():getGlobalPosition()
                    local distance = (_pos1.x - pos2.x)^2 + (_pos1.z - pos2.z)^2
                    return distance
end
function STONE_GATE_PORTCULLIS_COMP:update()
--    StoneGateBridge:log("STONE_GATE_PORTCULLIS_COMP:update()")
    if self.pos1 == nil then
        StoneGateBridge:log("STONE_GATE_PORTCULLIS_COMP:update() init pos1")
        self.pos1 = self:getOwner():getGlobalPosition()
        StoneGateBridge:log("STONE_GATE_PORTCULLIS_COMP:update() init pos2")
        self.pos2 = self.pos1.y + self.DeltaElevation
        return
    end
--    StoneGateBridge:log("STONE_GATE_PORTCULLIS_COMP:update() compute dt")
    local dt = self:getLevel():getDeltaTime()
    self.timer = self.timer - dt
    if self.timer < 0 then -- in case of pause (dt==0) nothing is executed
        -- check the proximity of a villager 
--        StoneGateBridge:log("STONE_GATE_PORTCULLIS_COMP:update() check proximity")
        local _proximity = false
  
        self:getLevel():getComponentManager("COMP_AGENT"):getAllComponent():forEach(
            function(comp)
                -- if proximity detected, bridgeOpen is executed only once
                if not _proximity then
                    if self:computeProximity(comp, self.pos1) < self.MinDistanceVillager then
                        _proximity = true
                        if self:portcullisOpen(dt) then
                            self.timer = 10 -- Wait on portcullis opened
                        else     
                            self.timer = 0 -- to execute the smooth opening rotation on each tick
                        end
                    end
                end
            end
        )
        if not _proximity then
            self:portcullisClose(dt)
            self.timer = 0 -- to recheck the proximity on each tick, wether execute the smooth closing rotation
        end
    end 
end

--------------------------------------------------------------------------
StoneGateBridge:registerClass(STONE_GATE_PORTCULLIS_COMP)
